precision highp float;

varying vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
//range: 0. to 5. default 1.
uniform float intensity;
uniform vec2 center;
uniform vec2 iResolution;

float rand(vec2 xy) {
    return fract(sin(dot(xy, vec2(12.9898, 78.233)))*43758.5453123);
}

vec4 zoomBlur(vec2 uv, sampler2D samp, vec2 center, float strength) {
    float offset = rand(uv);
    vec2 toCenter = uv - center;
    vec4 col = vec4(.0, .0, .0, 1.);
    float total = 0.;
    float blurSize = 1. * strength;
    float smapleSize = 60.;
    for (float t = 0.; t < smapleSize; t++) {
        float scaleX = 1.0 - blurSize * 1. / iResolution.x * t;
        float scaleY = 1.0 - blurSize * 1. / iResolution.y * t;
        col.rgb += texture2D(samp, vec2(toCenter.x * scaleX, toCenter.y * scaleY) + center).rgb;
    }
    col.rgb *= 1. / smapleSize;
    return col;
}

void main(){
    vec2 uv = textureCoordinate;
    vec4 color = vec4(1.);
    color = zoomBlur(uv, inputImageTexture, center, intensity);

    gl_FragColor = vec4(color.rgb, texture2D(inputImageTexture, textureCoordinate).a);
}
