precision highp float;
 
varying vec2 textureCoordinate;
 
uniform sampler2D inputImageTexture;
uniform vec2 iResolution;
uniform float uIntensity;
uniform float uDirection;

const int Samples = 32; //multiple of 2

vec4 DirectionalBlur(vec2 UV, vec2 Direction, float Intensity, sampler2D Texture)
{
    vec4 Color = vec4(0.0);
    
    vec2 aspect = iResolution.yy / iResolution.xy;
    
    for (int i = 1; i <= Samples / 2; i++) {
        Color += texture2D(Texture, aspect * (UV + float(i) * Intensity / float(Samples / 2) * Direction));
        Color += texture2D(Texture, aspect * (UV - float(i) * Intensity / float(Samples / 2) * Direction));
    }
    return Color/float(Samples);
}
 
 void main(){
     vec2 UV = textureCoordinate * iResolution.xy / iResolution.yy;
     vec2 Direction = vec2(cos(uDirection), sin(uDirection));
     float intensity = uIntensity * 0.1;
     vec4 color = DirectionalBlur(UV, Direction, intensity, inputImageTexture);
     gl_FragColor = color;
 }
