#define iChannel0 inputImageTexture
#define texture(a,b) texture2D(a,fract(b))
#define fragColor gl_FragColor
precision highp float;

varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;

//range (0., 0.) to (1., 1.)
uniform vec2 center;
//range 0.0 to 60. default 5.
uniform float angle;
uniform vec2 iResolution;

void main() {
    vec2 uv = textureCoordinate;
    vec2 v = uv - center;
    v.y *= iResolution.y / iResolution.x;
    float r = length(v);
    float d = 6.283185*r;
    float l = d*angle/360.0;
    float a = angle * 0.0174533;
    float amin = a/2.0;
    float speed = l * iResolution.x;
    int nSamples = int(clamp(speed, 1.01, 100.01));
    vec4 outColor = texture2D(inputImageTexture,uv);
    for(int i=1; i<nSamples; i++ ) {
        float sampleAngle = -amin + a * float(i)/float(nSamples);
        float s = sin(sampleAngle);
        float c = cos(sampleAngle);
        mat2 rot = mat2(c, -s, s, c);
        vec2 temp = v*rot;
        temp.y *= iResolution.x / iResolution.y;
        outColor += texture2D(inputImageTexture, center + temp);
    }
    gl_FragColor = outColor/float(nSamples);
}