precision highp float;

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform float ratio;
uniform float lineWidth;
uniform float frameWidth;

void main()
{
    vec4 base = texture2D(inputImageTexture, textureCoordinate);
    vec4 overlay = texture2D(inputImageTexture2, textureCoordinate2);
    vec4 lineColor = vec4(1.0);
    float coordX = textureCoordinate.x * frameWidth;
    float x = ratio * frameWidth;
    float value0 = step(coordX, x- lineWidth);
    float value1 = step(x + lineWidth, coordX);
    float valueL = step(x - lineWidth, coordX) + step(coordX, x + lineWidth);
    valueL = step(2.0, valueL);

    gl_FragColor = value0 * base + value1 * overlay  + valueL * lineColor;
}