precision highp float;

attribute vec2 aPosition;
attribute vec2 aTexCoord;

const lowp int GAUSSIAN_SAMPLES = 9;

uniform vec2 uOffset;

varying vec2 uTexCoord;
varying vec2 uBlurCoords[GAUSSIAN_SAMPLES];

void main() {
    gl_Position = vec4(aPosition, 0.0, 1.0);
    uTexCoord = aTexCoord;

    int multiplier = 0;
    vec2 blurStep;

    int samples_radius = (GAUSSIAN_SAMPLES - 1) / 2;
    for (int i = 0; i < GAUSSIAN_SAMPLES; i++) {
        multiplier = i - samples_radius;
        blurStep = float(multiplier) * uOffset;
        uBlurCoords[i] = aTexCoord + blurStep;
    }
}