precision highp float;

varying vec2 uTexCoord;

uniform sampler2D uTexture;

void main() {
    vec4 structure_tensor = texture2D(uTexture, uTexCoord);
    vec2 vector_field;
    if (structure_tensor.y != 0.) {
        vector_field = vec2(1., -structure_tensor.x / structure_tensor.y);
    } else if (structure_tensor.z == 0.) {
        vector_field = vec2(0., 1.);
    } else {
        vector_field = vec2(1., 0.);
    }
    gl_FragColor = vec4(normalize(vector_field), 0., 0.);
}
