precision highp float;

varying vec2 uTexCoord;

uniform sampler2D uTexture;

uniform vec2 uInverseResolution;

float rgb2gray(vec3 rgb_) {
    return rgb_.r * 0.299 + rgb_.g * 0.587 + rgb_.b * 0.114;
}

void main() {
    // scharr op to extract contours
    vec2 o_0 = uTexCoord + vec2(-uInverseResolution.x, -uInverseResolution.y);
    vec2 o_1 = uTexCoord + vec2(                   0., -uInverseResolution.y);
    vec2 o_2 = uTexCoord + vec2( uInverseResolution.x, -uInverseResolution.y);
    vec2 o_3 = uTexCoord + vec2(-uInverseResolution.x,  uInverseResolution.y);
    vec2 o_4 = uTexCoord + vec2(                   0.,  uInverseResolution.y);
    vec2 o_5 = uTexCoord + vec2( uInverseResolution.x,  uInverseResolution.y);
    float og_y = 10. * rgb2gray(texture2D(uTexture, o_4).rgb - texture2D(uTexture, o_1).rgb)
    + 3. * rgb2gray(texture2D(uTexture, o_3).rgb - texture2D(uTexture, o_0).rgb)
    + 3. * rgb2gray(texture2D(uTexture, o_5).rgb - texture2D(uTexture, o_2).rgb);

    o_0 = uTexCoord + vec2(-uInverseResolution.x, -uInverseResolution.y);
    o_1 = uTexCoord + vec2(-uInverseResolution.x,                    0.);
    o_2 = uTexCoord + vec2(-uInverseResolution.x,  uInverseResolution.y);
    o_3 = uTexCoord + vec2( uInverseResolution.x, -uInverseResolution.y);
    o_4 = uTexCoord + vec2( uInverseResolution.x,                    0.);
    o_5 = uTexCoord + vec2( uInverseResolution.x,  uInverseResolution.y);
    float og_x = 10. * rgb2gray(texture2D(uTexture, o_4).rgb - texture2D(uTexture, o_1).rgb)
    + 3. * rgb2gray(texture2D(uTexture, o_3).rgb - texture2D(uTexture, o_0).rgb)
    + 3. * rgb2gray(texture2D(uTexture, o_5).rgb - texture2D(uTexture, o_2).rgb);

    gl_FragColor = vec4(og_x * og_x, og_x * og_y, og_y * og_y, 0.);
}
