precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform int blendMode;

void main(){
    vec4 color1 = texture2D(inputImageTexture, textureCoordinate);
    vec4 color2 = texture2D(inputImageTexture2, textureCoordinate);
    vec4 color3 = vec4(0.0);
    if (blendMode == 0) {
        if (color2.a == 1.0) {
            gl_FragColor = vec4(0.0);
        } else {
            gl_FragColor = vec4(color1.rgb, 1.0 - color2.a);
        }
    } else if (blendMode == 1) {
        gl_FragColor = vec4(color1.rgb * color2.a,color2.a);
    } else if (blendMode == 2){
        gl_FragColor = mix(color1, color3, 1.0 - color2.a);
    } else if (blendMode == 3) {
        if (color1.a == 0.0) {
            gl_FragColor = vec4(0.0);
        } else {
            gl_FragColor = mix(vec4(0.0), color2, color1.a);
        }
    } else if (blendMode == 4) {
        if (color2.a == 1.0) {
            gl_FragColor = color1;
        } else {
            gl_FragColor = vec4(color1.rgb, color2.a);
        }
    }
}
