precision highp float;
const lowp int GAUSSIAN_SAMPLES = 9;


uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;
varying highp vec2 blurCoordinates[GAUSSIAN_SAMPLES];

bool pointInRect(vec2 point) {
    if (point.x >= 0.0 && point.x <= 1.0 && point.y >= 0.0 && point.y <= 1.0) {
        return true;
    }
    return false;
}

void main()
{
    lowp vec4 sum = vec4(0.0);
    lowp vec4 fragColor=texture2D(inputImageTexture, textureCoordinate);
    
    if(pointInRect(blurCoordinates[0])) {
        sum += texture2D(inputImageTexture, blurCoordinates[0]) * 0.05;
    }
    if(pointInRect(blurCoordinates[1])) {
        sum += texture2D(inputImageTexture, blurCoordinates[1]) * 0.09;
    }
    if(pointInRect(blurCoordinates[2])) {
        sum += texture2D(inputImageTexture, blurCoordinates[2]) * 0.12;
    }
    if(pointInRect(blurCoordinates[3])) {
        sum += texture2D(inputImageTexture, blurCoordinates[3]) * 0.15;
    }
    if(pointInRect(blurCoordinates[4])) {
        sum += texture2D(inputImageTexture, blurCoordinates[4]) * 0.18;
    }
    if(pointInRect(blurCoordinates[5])) {
        sum += texture2D(inputImageTexture, blurCoordinates[5]) * 0.15;
    }
    if(pointInRect(blurCoordinates[6])) {
        sum += texture2D(inputImageTexture, blurCoordinates[6]) * 0.12;
    }
    if(pointInRect(blurCoordinates[7])) {
        sum += texture2D(inputImageTexture, blurCoordinates[7]) * 0.09;
    }
    if(pointInRect(blurCoordinates[8])) {
        sum += texture2D(inputImageTexture, blurCoordinates[8]) * 0.05;
    }
    
    gl_FragColor = sum;
}
