precision highp float;
attribute vec4 position;
attribute vec2 aTextureCoord;
uniform mat4 vertexMatrix;
uniform mat4 textureMatrix;

const int GAUSSIAN_SAMPLES = 9;

uniform float texelWidthOffset;
uniform float texelHeightOffset;

varying vec2 textureCoordinate;
varying vec2 blurCoordinates[GAUSSIAN_SAMPLES];

void main()
{
    gl_Position = vertexMatrix * position;
    textureCoordinate = (textureMatrix * vec4(aTextureCoord, 0.0, 1.0)).xy;;

    // Calculate the aPositions for the blur
    int multiplier = 0;
    vec2 blurStep;
    vec2 singleStepOffset = vec2(texelWidthOffset, texelHeightOffset);

    for (int i = 0; i < GAUSSIAN_SAMPLES; i++)
    {
        multiplier = (i - ((GAUSSIAN_SAMPLES - 1) / 2));
        // Blur in x (horizontal)
        blurStep = float(multiplier) * singleStepOffset;
        blurCoordinates[i] = textureCoordinate.xy + blurStep;
    }
}

