precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture; //base
uniform sampler2D inputImageTexture2;//mask
uniform sampler2D inputImageTexture3;//overlay
uniform float hasOverlay;

uniform vec2 offset;

vec4 blend_normal(vec4 base, vec4 overlay) {
    return base + overlay - base * overlay.a;
}

void main()
{
    vec4 base = texture2D(inputImageTexture, textureCoordinate);
    vec4 base2 = texture2D(inputImageTexture, vec2(textureCoordinate.x + offset.x, textureCoordinate.y - offset.y));

    vec4 mask = texture2D(inputImageTexture2, textureCoordinate);
    mask = mix(vec4(0.,0.,0.,mask.a), base2, mask.g);

    if (hasOverlay > 0.) {
        vec4 overlay = texture2D(inputImageTexture3, textureCoordinate);
        base = blend_normal(base, overlay);
    }
    gl_FragColor = blend_normal(base, mask);
}