precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D texture;

uniform float type;

uniform vec4 hsv;

#define PI 3.141592653

vec3 hsv2rgb(vec3 c)
{
    vec3 rgb = clamp(abs(mod(c.x*6.0+vec3(0.0, 4.0, 2.0), 6.0)-3.0)-1.0, 0.0, 1.0);
    return c.z * mix(vec3(1.0), rgb, c.y);
}

vec4 line(vec2 uv) {
    vec3 col = mix(vec3(1.), hsv2rgb(hsv.rgb), step(1., hsv.a));
    //    col = hsv2rgb(vec3(1., 1., 1.));

    //    vec3 col = vec3(1.);
    vec4 col1;
    vec4 col2;

    {
        float v = abs(uv.y - 0.5);
        v = 0.5 - v;
        v = smoothstep(0., 0.01, v);
        v = clamp(v, 0., 1.);
        col1 = vec4(col, v);
    }
    {
        float v = distance(uv, vec2(0.5));
        v = smoothstep(0.5*(1. - 0.01), 0.5, v);
        v = 1. - v;
        v = clamp(v, 0., 1.);
        col2 = vec4(col, v);
    }

    return mix(col1, col2, step(1., type));
}

void main() {
    vec4 col = line(textureCoordinate);
    gl_FragColor = col;
}
