precision highp float;

#define TWO_PI 6.28318530718
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform vec2 size;
uniform float angle;
uniform float radius;
uniform float strength;
uniform int trigger;

void main(){
    vec3 color = texture2D(inputImageTexture, textureCoordinate).rgb;

    vec3 result = vec3(0.);
    float weight = 1.;
    float weights = 0.;
    vec2 loc = vec2(0.);
    if (size.x > 0. && size.y > 0.) {
        for (float i = -radius; i <= radius; i++){
            loc = textureCoordinate + i * 3. * vec2(cos(angle), sin(angle)) / size;
            result += weight * texture2D(inputImageTexture, loc).rgb;
            weights += weight;
        }
    }

    if (weights < 1.){
        weights = 1.;
    }
    result = result / weights;
    result = mix(color, result, strength);

    if (trigger < 1){
        gl_FragColor = vec4(result, 1.);
    } else {
        vec4 mask = texture2D(inputImageTexture2, vec2(textureCoordinate.x, 1.0 - textureCoordinate.y));
        gl_FragColor = vec4(mix(color, result, mask.a), 1.);

    }

}