
precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform float minLimit;
uniform float maxLimit;
uniform int inverted;

//const vec3 luminanceWeighting = vec3(0.2126, 0.7152, 0.0722);
const vec3 luminanceWeighting = vec3(0.299, 0.587, 0.114);

void main() {
    vec4 color = texture2D(inputImageTexture, textureCoordinate);
    float luminance = dot(color.rgb, luminanceWeighting);

    bool shouldShow = luminance <= maxLimit && luminance >= minLimit;
    if (inverted == 1) {
        shouldShow = !shouldShow;
    }

    if (shouldShow) {
        gl_FragColor = color;
    } else {
        gl_FragColor = vec4(0.0);
    }
}
