precision highp float;
uniform sampler2D inputImageTexture;
varying vec2 vTexCoord;

uniform float threshold1;
uniform float threshold2;
uniform vec2 d0;
uniform vec2 d1;
uniform vec2 d2;
uniform vec2 d3;
uniform vec2 d4;
uniform vec2 d5;
uniform vec2 d6;
uniform vec2 d7;
uniform vec2 d8;
uniform vec2 d9;

float cmul(vec3 c3) {
    return dot(c3, c3) * 0.333;
}
float stresh(float v, float threshold) {
    return clamp((v - threshold) * 5.0, 0.0, 1.0);
}

void main()
{
    vec2 tc = vTexCoord;
    vec4 color = texture2D(inputImageTexture, tc);
    float c = stresh(cmul(texture2D(inputImageTexture, tc).rgb), threshold1);
    c *= 1.0 - stresh(cmul(texture2D(inputImageTexture, tc + d0.xy).rgb), threshold2);
    c *= 1.0 - stresh(cmul(texture2D(inputImageTexture, tc + d1.xy).rgb), threshold2);
    c *= 1.0 - stresh(cmul(texture2D(inputImageTexture, tc + d2.xy).rgb), threshold2);
    c *= 1.0 - stresh(cmul(texture2D(inputImageTexture, tc + d3.xy).rgb), threshold2);
    c *= 1.0 - stresh(cmul(texture2D(inputImageTexture, tc + d4.xy).rgb), threshold2);
    c *= 1.0 - stresh(cmul(texture2D(inputImageTexture, tc + d5.xy).rgb), threshold2);
    c *= 1.0 - stresh(cmul(texture2D(inputImageTexture, tc + d6.xy).rgb), threshold2);
    c *= 1.0 - stresh(cmul(texture2D(inputImageTexture, tc + d7.xy).rgb), threshold2);
    c *= 1.0 - stresh(cmul(texture2D(inputImageTexture, tc + d8.xy).rgb), threshold2);
    c *= 1.0 - stresh(cmul(texture2D(inputImageTexture, tc + d9.xy).rgb), threshold2);
    gl_FragColor = vec4(c, c, c, 1.0) * color.a;
}
