precision highp float;
varying vec2 textureCoordinate;
// uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;

uniform vec4 maskRect;
uniform vec2 resolution;
uniform vec2 resSize;

lowp vec4 blend_normal(lowp vec4 base, lowp vec4 overlay) {
    return base + overlay - base * overlay.a;
}

lowp vec4 getResColor() {
    vec2 uv = vec2(textureCoordinate.x, 1.0 - textureCoordinate.y) * resolution;
    if (any(lessThan(uv, maskRect.xy)) || any(greaterThan(uv, maskRect.xy + maskRect.zw))) {
        return vec4(0.);
    }
    float resX = mod(uv.x - maskRect.x, resSize.x) / resSize.x;
    float resY = mod(uv.y - maskRect.y, resSize.y) / resSize.y;
    return texture2D(inputImageTexture3, vec2(resX, resY));
}

void main()
{
    // lowp vec4 base = texture2D(inputImageTexture, textureCoordinate);
    lowp vec4 hair = texture2D(inputImageTexture2, vec2(textureCoordinate.x , 1.0 - textureCoordinate.y));
    gl_FragColor = getResColor() * hair.r; // mix(base, blend_normal(base, getResColor()), hair.r);
}