precision mediump float;

varying vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float verticeSize;

vec2 data2uv(vec4 data) {
    return data.xy + data.zw / 255.;
}

vec4 interpolationUV(vec2 uv){
    vec2 fxy = fract(uv * verticeSize);
    vec2 uv_bl = uv - fxy/verticeSize;
    vec4 bl = texture2D(inputImageTexture2, uv_bl);
    vec4 tl = texture2D(inputImageTexture2, uv_bl+vec2(0.0, 1.0/verticeSize));
    vec4 br = texture2D(inputImageTexture2, uv_bl+vec2(1.0/verticeSize, 0.0));
    vec4 tr = texture2D(inputImageTexture2, uv_bl+vec2(1.0/verticeSize));
    return bl*(1.0-fxy.x)*(1.0-fxy.y) + tl*(1.0-fxy.x)*fxy.y + br*fxy.x*(1.0-fxy.y) + tr*fxy.x*fxy.y;
}

void main()
{
    vec4 data = interpolationUV(textureCoordinate);
    vec2 uv = data2uv(data);
    vec4 textureColor = texture2D(inputImageTexture, uv);
    gl_FragColor = textureColor;
}
