precision highp float;

attribute vec4 position;

uniform sampler2D inputImageTexture2;

varying vec2 textureCoordinate;

uniform vec2 verticeSize;

vec2 uv2uvInt(vec2 uv) {
    return floor(uv * verticeSize) / (verticeSize - 1.0);
}

vec2 uvInt2uv(vec2 uvInt) {
    return (floor(uvInt * (verticeSize - 1.0) + 0.5) + 0.5) / verticeSize;
}

vec4 uvInt2data(vec2 uvInt) {
    vec2 xy = uvInt * 255.;
    vec2 fxy = fract(xy) * 255.;
    xy = floor(xy) / 255.;
    fxy = floor(fxy + 0.5) / 255.;
    return vec4(xy, fxy);
}

vec2 data2uvInt(vec4 data) {
    vec2 xy = floor(data.xy * 255. + 0.5);
    vec2 fxy = floor(data.zw * 255. + 0.5);
    vec2 uvInt = (xy + fxy / 255.) / 255.;
    return uvInt;
}

vec4 uv2data(vec2 uv) {
    return uvInt2data(uv2uvInt(uv));
}

vec2 data2uv(vec4 data) {
    return uvInt2uv(data2uvInt(data));
}

void main()
{

    vec2 uvInt = (position.xy + 1.0) / 2.0;
    textureCoordinate = vec2(uvInt.x, 1.0 - uvInt.y);

    gl_Position = vec4(data2uvInt(texture2D(inputImageTexture2, uvInt2uv(uvInt))) * 2.0 - 1.0, position.zw);
}
