#version 300 es

precision highp float;

in highp vec2 textureCoordinate;

layout(location = 0) out mediump vec4 fragColor;

uniform sampler2D inputImageTexture;

uniform vec2 liquidPoints[8];
uniform vec4 liquidPointProperties[8]; // xy: dir, z: radius, w: strength
uniform int liquidPointCount;

uniform vec2 iResolution;

float lengthSquared(vec2 v)
{
    return v.x * v.x + v.y * v.y;
}

//vec2 curveWarp(vec2 textureCoord, vec2 originPosition, vec2 targetPosition, float radius)
//{
//    vec2 offset = vec2(0.0);
//    vec2 result = vec2(0.0);
//
//    vec2 direction = targetPosition - originPosition;
//
//    float infect = distance(textureCoord, originPosition)/radius;
//
//    infect = 1.0 - infect;
//    infect = clamp(infect, 0.0, 1.0);
//    offset = direction * infect;
//
//    result = textureCoord - offset;
//
//    return result;
//}

vec2 move(vec2 texcoord, vec2 center, float radius, vec2 direction)
{
    vec2 offset = vec2(0.0);
    vec2 result = vec2(0.0);

    float infect = length(texcoord - center)/radius;

    infect = 1.0 - infect;
    infect = clamp(infect, 0.0, 1.0);
    offset = direction * infect;

    result = texcoord - offset;

    return result;
    
//    float dist = length(texcoord - center);
//    if (dist > radius) {
//        return texcoord;
//    } else {
//        float a = radius * radius - pow(dist, 2.0);
//        float b = pow(a/(a+lengthSquared(direction)), 2.0);
//        return texcoord - b * direction;
//    }
}

void main()
{
    vec2 texcoord = textureCoordinate * iResolution;
    for (int i = liquidPointCount - 1; i >= 0; i--) {
        texcoord = move(texcoord, liquidPoints[i], liquidPointProperties[i].z, normalize(liquidPointProperties[i].xy) * liquidPointProperties[i].w);
    }
    fragColor = texture(inputImageTexture, texcoord / iResolution);
}
