#version 300 es

precision highp float;

in highp vec2 textureCoordinate;
in highp vec2 aaa;
in highp float strength;

layout(location = 0) out mediump vec4 fragColor;

uniform sampler2D srcTexture;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform float uStrength;

//uniform vec2 iResolution;

//vec4 blend(vec4 base, vec4 overlay) {
//    return base + overlay - base * overlay.a;
//}

vec4 blend(vec4 base, vec4 overlay) {
    return (1.0 - overlay.a) * base + (1.0 - base.a) * overlay + base * overlay;
}

float getIntensity(vec3 color) {
    float bb = max(0., color.r - color.g);
    float cc = bb * bb * 100.;
    cc = max(0., cc);
    cc = min(1., cc);
    return cc;
}

void main()
{
    vec4 base = texture(srcTexture, (aaa + 1.0) * 0.5);
    vec4 overlay = texture(inputImageTexture, textureCoordinate);
    float alpha = 1.0 - texture(inputImageTexture2, (aaa + 1.0) * 0.5).a;
    fragColor = blend(base, overlay * uStrength * getIntensity(base.rgb) * alpha * strength);
}
