precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D maskTexture1;
uniform sampler2D maskTexture2;
uniform float autoIntensity;
uniform float manualIntensity;
uniform vec4 color3Ratio1;
uniform vec4 color3Ratio2;
uniform float useColor;

void main(){
    vec4 mask1 = texture2D(maskTexture1, textureCoordinate);
    vec4 mask2 = texture2D(maskTexture2, textureCoordinate);
    float mask1Color = length(mask1 * color3Ratio1);
    float mask2Color = length(mask2 * color3Ratio2);
    float ra = 1. - pow(1. - (mask1Color * autoIntensity + mask2Color * manualIntensity) * 0.5, 3.);
    gl_FragColor = vec4(mix(1.0, ra, useColor), 0., 0., mix(ra, 1.0, useColor));
}
