precision highp float;

varying vec2 outTexCoord;
uniform sampler2D texture;

uniform vec2 eyeCenter[2];
uniform float eyeRadius[2];

uniform vec2 iResolution;

void main() {
    vec2 uv = outTexCoord;

    vec2 centerLeft = eyeCenter[0] * iResolution;
    float leftRadius = eyeRadius[0] * iResolution.y;
    vec2 uvSize = uv * iResolution;

    if (distance(uvSize, centerLeft) < leftRadius) {
        gl_FragColor = vec4(1.0);
        return;
    }

    vec2 centerRight = eyeCenter[1]* iResolution;
    float rightRadius = eyeRadius[1]* iResolution.y;

    if (distance(uvSize, centerRight) < rightRadius) {
        gl_FragColor = vec4(1.0);
        return;
    }

        gl_FragColor = vec4(0.0);
    gl_FragColor = texture2D(texture, uv);
}