precision highp float;

uniform sampler2D srcTexture;

varying vec2 srcTexCoord;
varying vec2 maskTexCoord;

uniform vec2 fromPoint;
uniform vec2 toPoint;
uniform float pencil;
uniform float radius;
uniform vec2 uSize;

vec4 drawLine(vec4 srcColor, vec2 p) {
    vec2 pa = p - fromPoint;
    vec2 ba = toPoint - fromPoint;
    float h = clamp(dot(pa, ba)/dot(ba, ba), 0.0, 1.0);
    if (length(pa - ba*h) <= radius) {
        return vec4(1. * pencil, 1. * (1. - pencil), 0. * (1. - pencil), 1.);
    }
    return srcColor;
}

void main() {
    vec4 iColor = texture2D(srcTexture, srcTexCoord);

    gl_FragColor = drawLine(iColor, maskTexCoord.xy * uSize);
}





