precision highp float;

uniform sampler2D src2mask;
uniform sampler2D maskOffset;
varying vec2 texCoord;
#define iszero(u) (abs(u.x) < 1e-4 && abs(u.y) < 1e-4)
#define iszero4(u) (iszero(u.xy) && iszero(u.zw))

vec2 data2uv(vec4 data) {
    vec2 xy = floor(data.xy * 255. + 0.5);
    vec2 fxy = floor(data.zw * 255. + 0.5);
    vec2 uv = (xy + fxy / 255.) / 255.;
    return uv;
}

void main() {
    vec2 maskUV = data2uv(texture2D(src2mask, texCoord.xy));
    vec4 offsetdata = texture2D(maskOffset, maskUV);
    if (iszero(maskUV) || iszero4(offsetdata)) {
      gl_FragColor = vec4(0.0);
    } else {
      gl_FragColor = offsetdata;
    }
}