attribute vec2 position;

uniform sampler2D src2mask;
uniform sampler2D maskOffset;

uniform vec4 faceRect;

varying vec2 texCoord;

vec2 data2uv(vec4 data) {
    vec2 xy = floor(data.xy * 255. + 0.5);
    vec2 fxy = floor(data.zw * 255. + 0.5);
    vec2 uv = (xy + fxy / 255.) / 255.;
    return uv;
}

void main()
{
    texCoord = position.xy * faceRect.zw + faceRect.xy;
    
    vec2 maskUV = data2uv(texture2D(src2mask, position.xy));
    vec4 offsetdata = texture2D(maskOffset, maskUV);
    gl_Position = vec4(texCoord * 2.0 - 1.0, 0.0, 1.0);
}
