precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D srcTexture;
uniform sampler2D overlayTexture;
uniform vec4 maskRect;

bool isWithinRange(vec2 coord) {
    return coord.x >= 0.0 && coord.x <= 1.0 && coord.y >= 0.0 && coord.y <= 1.0;
}

void main() {
    vec4 base = texture2D(srcTexture, textureCoordinate);
    vec2 maskSamplePos = (textureCoordinate - maskRect.xy) / maskRect.zw;
    vec4 overlay;
    if (isWithinRange(maskSamplePos)) {
        overlay = texture2D(overlayTexture, maskSamplePos);
    } else {
        overlay = vec4(0.);
    }
    gl_FragColor = clamp(base + overlay, 0., 1.);
}
