precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D srcTexture;
uniform sampler2D overlayTexture;
uniform sampler2D maskTexture;
uniform vec4 maskRect;

uniform float strength;
uniform float gam;

bool isWithinRange(vec2 coord) {
    return coord.x >= 0.0 && coord.x <= 1.0 && coord.y >= 0.0 && coord.y <= 1.0;
}

void main() {
    vec4 src = texture2D(srcTexture, textureCoordinate);
    vec4 overlay = texture2D(overlayTexture, textureCoordinate);
    vec2 maskSamplePos = (textureCoordinate - maskRect.xy) / maskRect.zw;
    float mask;
    if (isWithinRange(maskSamplePos)) {
        mask = texture2D(maskTexture, maskSamplePos).r;
    } else {
        mask = 0.;
    }

    vec4 fillMaskColor = vec4(vec3(pow(overlay.b, gam) * strength * mask), 1.);
    gl_FragColor = clamp(src + fillMaskColor, 0., 1.);//V5

//    gl_FragColor = mix(src, overlay, mask * opacity);
}
