precision highp float;

varying highp vec2 textureCoordinate;
uniform sampler2D inputTexture;
uniform sampler2D maskTexture;
uniform sampler2D fineTexture;

uniform float strength;

const vec3 grayXfer = vec3(0.3, 0.59, 0.11);

void main(){

    vec4 color = texture2D(inputTexture, textureCoordinate.xy);
    vec4 maskColor = texture2D(maskTexture, textureCoordinate.xy);


    vec3 fineColor = texture2D(fineTexture, textureCoordinate.xy).rgb;
    color.rgb = mix(color.rgb, fineColor.rgb, maskColor.g * strength);


    gl_FragColor = color;
}