precision highp float;

#define fragCoord textureCoordinate
#define texture texture2D
#define fragColor gl_FragColor
#define iChannel0 inputImageTexture
#define iChannel1 inputImageTexture2
#define iChannel2 inputImageTexture3

varying  vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;

uniform vec4 roiRect;


void main() {
    if (textureCoordinate.x <= roiRect.x || textureCoordinate.y <= roiRect.y || textureCoordinate.x >= roiRect.x + roiRect.z || textureCoordinate.y >= roiRect.y + roiRect.w) {
        fragColor = texture(iChannel0, textureCoordinate);
    } else {
        // in roi
        vec2 coorInROI = vec2((textureCoordinate.x - roiRect.x) / roiRect.z, (textureCoordinate.y - roiRect.y) / roiRect.w);

        vec4 srcColor = texture(iChannel0, textureCoordinate);
        vec4 mlResultColor = texture(iChannel1, coorInROI);
        vec4 maskColor = texture(iChannel2, coorInROI);

        // pm优化
        float p = step(0.1, maskColor.r);
        fragColor = srcColor * (1. - p) + mlResultColor * p;
    }
}