precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D maskTexture;
uniform vec4 fillColor;
uniform float keepSrc;

void main(){
    vec4 src = texture2D(inputImageTexture, textureCoordinate);
    vec4 mask = texture2D(maskTexture, textureCoordinate);
    gl_FragColor = vec4(mix(src.rgb * keepSrc, fillColor.rgb, mask.a * fillColor.a), mask.a * mix(fillColor.a, src.a, keepSrc));
}