
precision mediump float;

#define oriTexture          inputImageTexture
#define smallBlurTexture    inputImageTexture2
#define largeBlurTexture    inputImageTexture3
#define maskTexture         inputImageTexture4
#define skinTexture         inputImageTexture5

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform sampler2D inputImageTexture4;
uniform sampler2D inputImageTexture5;

varying highp vec2 textureCoordinate;

vec3 lum = vec3(0.2989, 0.5866, 0.1145);

void main() {
    vec4 c = texture2D(oriTexture, textureCoordinate);
    vec3 iColor = c.rgb;
    vec3 oColor = iColor;
    vec3 maskValue = texture2D(maskTexture, textureCoordinate).rgb;
    if (maskValue.r > 0.005) {

        vec3 sBlur = texture2D(smallBlurTexture, textureCoordinate).rgb;
        vec3 lBlur = texture2D(largeBlurTexture, textureCoordinate).rgb;
        
        // 看起来是绿色分量的强度越大，这个值越小，最小为0.7，最大为1.0
        // 看起来是用来减弱脸部以及眉毛间区域的匀肤强度的？
        float c1 = 1.0 - 0.3 * mix(0.0, clamp((maskValue.g - 0.02) * 1.02001, 0.0, 1.0), step(0.019999, maskValue.g));
        
        float multiplier;
//        multiplier = max(max(sBlur.g - 0.25, 0.0) * 4.8, max(0.25 - sBlur.g, 0.0) * 14.4);
        float slum = dot(sBlur, lum);
        float llum = dot(lBlur, lum);
        if (slum > llum) {
            multiplier = 0.5;
        } else {
            float threshold = 0.25;
            if (sBlur.g > 0.25) {
                multiplier = pow((sBlur.g - threshold), 0.9) * 4.8;
            } else if (sBlur.g > 0.10) {
                multiplier = pow((threshold - sBlur.g), 1.0) * 14.4;
            } else {
                multiplier = 0.3;
            }
        }
        
        vec3 tColor = iColor - (mix(iColor, sBlur, c1) - lBlur) * multiplier;
        tColor = clamp(tColor, 0.0, 1.0);
        
//        vec3 tColor = clamp(iColor - (c1 * sBlur + (1. - c1) * iColor - lBlur) * max(max(d.g - 0.25, 0.) * 4.8, max(0.25 - d.g, 0.) * 14.4), 0.0, 1.0);
        
        // 另外一个强度，当前像素的亮度越高，值越小，用来决定最终的混合强度
//        float r5 = max(dot(iColor, lum) - 0.2, 0.0) / 0.8;
//        r5 = clamp(1.0 - r5 * r5 * r5, 0.0, 1.0);
//        r5 = min(maskValue.r, 1.0 - maskValue.b) * r5;
        
        float r5 = max(dot(iColor, lum) - 0.412, 0.0) / 0.588;
        r5 = clamp(1.0 - r5 * r5 * r5, 0.0, 1.0);
        r5 = min(maskValue.r, 1.0 - pow(maskValue.b, 0.5)) * r5;
        r5 *= texture2D(skinTexture, textureCoordinate).r;
        
        oColor = mix(iColor, tColor, r5);
    }
    gl_FragColor = vec4(oColor, c.a);
}
