
precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;

#define STEP 0.022

#define STEP2 0.011

float blendLinearLight(float base, float blend) {
    return (base+2.0*blend-1.0);
}

vec3 blendLinearLight(vec3 base, vec3 blend) {
    return vec3(blendLinearLight(base.r, blend.r), blendLinearLight(base.g, blend.g), blendLinearLight(base.b, blend.b));
}

void main()
{
    vec4 iColor = texture2D(inputImageTexture, textureCoordinate);
    vec3 oColor = iColor.rgb;

    float intensity = texture2D(inputImageTexture3, textureCoordinate).r;
    if (intensity > 0.01) {
        intensity = pow(intensity, 0.3);

        vec3 colors[9];
        colors[0] = iColor.rgb;
        colors[1] = texture2D(inputImageTexture2, textureCoordinate + STEP * vec2(0.707, 0.707)).rgb;
        colors[2] = texture2D(inputImageTexture2, textureCoordinate + STEP * vec2(0.707, -0.707)).rgb;
        colors[3] = texture2D(inputImageTexture2, textureCoordinate + STEP * vec2(-0.707, 0.707)).rgb;
        colors[4] = texture2D(inputImageTexture2, textureCoordinate + STEP * vec2(-0.707, -0.707)).rgb;
        colors[5] = texture2D(inputImageTexture2, textureCoordinate + STEP * vec2(0.0, -1.0)).rgb;
        colors[6] = texture2D(inputImageTexture2, textureCoordinate + STEP * vec2(0.0, 1.0)).rgb;
        colors[7] = texture2D(inputImageTexture2, textureCoordinate + STEP * vec2(1.0, 0.0)).rgb;
        colors[8] = texture2D(inputImageTexture2, textureCoordinate + STEP * vec2(-1.0, 0.0)).rgb;

        vec3 avg = colors[1] + colors[2] + colors[3] + colors[4] + colors[5] + colors[6] + colors[7] + colors[8];
        avg = avg / 8.0;

        oColor = mix(iColor.rgb, avg, intensity);
    }

    gl_FragColor = vec4(oColor, iColor.a);
}
