#version 300 es

precision highp float;

in highp vec2 textureCoordinate;
in highp vec2 textureCoordinate2;
in highp vec2 textureCoordinate3;

layout(location = 0) out mediump vec4 finalColor;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;

vec3 weights = vec3(0.2989, 0.5866, 0.1145);

float nonlinear_map(float a) {
    if (a > 0.0) {
        return log(a + 1.0) * 0.7;
    } else {
        return -log(abs(a) + 1.0) * 0.7;
    }
}

vec3 nonlinear_map(vec3 color) {
    return vec3(nonlinear_map(color.r), nonlinear_map(color.g), nonlinear_map(color.b));
}

void main() {
    vec3 skinMask = texture(inputImageTexture3, textureCoordinate).rgb;
    float mask = clamp(skinMask.r - skinMask.b, 0.0, 1.0); // 1.0 - texture(inputImageTexture3, textureCoordinate3).b;
    vec4 color1 = texture(inputImageTexture, textureCoordinate);
    vec4 color2 = texture(inputImageTexture2, textureCoordinate2);
    float diff = dot(color1.rgb, weights) - dot(color2.rgb, weights);
    finalColor = vec4(vec3(nonlinear_map(diff) * mask + 0.5), 1.0);
    //    vec4 diff = color1 - color2;
    //    finalColor = vec4(nonlinear_map(diff.rgb) + 0.5, 1.0);
}
