
#define vTexCoord   textureCoordinate
#define sTexture    inputImageTexture
#define u_Texture1  inputImageTexture2
#define u_Texture2  inputImageTexture3

precision highp float;

precision highp float;
varying vec2 vTexCoord;
uniform sampler2D sTexture;
uniform sampler2D u_Texture1;
uniform float skinTextureIntensity;


float blendLinearLight(float base, float blend) {
    //return blend<0.5?blendLinearBurn(base,(2.0*blend)):blendLinearDodge(base,(2.0*(blend-0.5)));
    return (base+2.0*blend-1.0);
}

vec3 blendLinearLight(vec3 base, vec3 blend) {
    return vec3(blendLinearLight(base.r, blend.r), blendLinearLight(base.g, blend.g), blendLinearLight(base.b, blend.b));
}

vec4 blendLinearLight(vec4 base, vec4 blend) {
    return vec4(blendLinearLight(base.r, blend.r), blendLinearLight(base.g, blend.g), blendLinearLight(base.b, blend.b), base.a);
}

void main()
{
    lowp vec4 color = texture2D(sTexture, vTexCoord);
    lowp vec4 sucaiColor = texture2D(u_Texture1, vTexCoord);

    if (sucaiColor.a > 0.0)
    sucaiColor.rgb = clamp(sucaiColor.rgb/sucaiColor.a, 0.0, 1.0);

    lowp vec4 result  = blendLinearLight(color, sucaiColor);
    lowp float intensity = skinTextureIntensity;
    result = mix(color, result, sucaiColor.a * intensity);
    gl_FragColor = vec4(result.rgb, color.a);
}

