precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform float distanceBottom;
uniform float distanceTop;
uniform float scale;

#func_data2offset
#func_offset2data

void main() {
    vec2 uv = textureCoordinate;
    uv.y = 1.0 - uv.y;
    float stretchHeight = 1.0 - distanceTop - distanceBottom;
    float newStretchHeight = stretchHeight * scale;
    float f = 1.0 / (distanceTop + distanceBottom + newStretchHeight);
    float t1 = distanceTop * f;
    float b1 = distanceBottom * f;

    float y = uv.y;
    if (y < t1) {
        y = mix(0.0, distanceTop, y / t1);
    } else if (1.0 - y < b1) {
        y = mix(1.0, 1.0 - distanceBottom, (1.0 - y) / b1);
    } else {
        y = mix(distanceTop, 1.0 - distanceBottom, (y - t1) / (1.0 - b1 - t1));
    }

    uv = vec2(uv.x, y);
    uv.y = 1.0 - uv.y;

    vec2 offset = uv - textureCoordinate;
    vec2 inOffset = data2offset(texture2D(inputImageTexture, textureCoordinate));
    gl_FragColor = offset2data(inOffset + offset);
}