precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

#TEX_SIZE_DEFINE

#func_data2offset

vec2 interp(vec2 uv){
    vec2 fxy = fract(uv * TEX_SIZE);
    vec2 uv_bl = uv - fxy/TEX_SIZE;
    vec2 bl = data2offset(texture2D(inputImageTexture2, uv_bl));
    vec2 tl = data2offset(texture2D(inputImageTexture2, uv_bl+vec2(0.0,1.0/TEX_SIZE)));
    vec2 br = data2offset(texture2D(inputImageTexture2, uv_bl+vec2(1.0/TEX_SIZE,0.0)));
    vec2 tr = data2offset(texture2D(inputImageTexture2, uv_bl+vec2(1.0/TEX_SIZE)));
    return (1.0-fxy.x)*(1.0-fxy.y)*bl + (1.0-fxy.x)*fxy.y*tl + fxy.x*(1.0-fxy.y)*br + fxy.x*fxy.y*tr;
}

void main(void) {
    vec2 offset = interp(textureCoordinate - 0.5/TEX_SIZE);
    gl_FragColor = texture2D(inputImageTexture, textureCoordinate + offset);
}