precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
#define VERTICE_SIZE 512.0

#ifdef ENABLE_FLOAT_TEXTURE
vec2 data2offset(vec4 data) {
    return data.xy;
}
#else
vec2 data2uv(vec4 data) {
    vec2 xy = floor(data.xy * 255. + 0.5);
    vec2 fxy = floor(data.zw * 255. + 0.5);
    vec2 uv = (xy + fxy / 255.) / 255.;
    return uv;
}
vec2 data2offset(vec4 data) {
    return (data2uv(data) - 0.5) * 2.0;
}
#endif

vec2 interp(vec2 uv){
    vec2 fxy = fract(uv * VERTICE_SIZE);
    vec2 uv_bl = uv - fxy/VERTICE_SIZE;
    vec2 bl = data2offset(texture2D(inputImageTexture2, uv_bl));
    vec2 tl = data2offset(texture2D(inputImageTexture2, uv_bl+vec2(0.0,1.0/VERTICE_SIZE)));
    vec2 br = data2offset(texture2D(inputImageTexture2, uv_bl+vec2(1.0/VERTICE_SIZE,0.0)));
    vec2 tr = data2offset(texture2D(inputImageTexture2, uv_bl+vec2(1.0/VERTICE_SIZE)));
    return (1.0-fxy.x)*(1.0-fxy.y)*bl + (1.0-fxy.x)*fxy.y*tl + fxy.x*(1.0-fxy.y)*br + fxy.x*fxy.y*tr;
}

void main(void) {
    vec2 offset = interp(textureCoordinate - 0.5/VERTICE_SIZE);
    gl_FragColor = texture2D(inputImageTexture, textureCoordinate + offset);

    //gl_FragColor = vec4(offset.x * 100.0, offset.y * 100.0, 0.0, 1.0);
}