
    precision highp float;

    varying vec2 textureCoordinate;
    uniform sampler2D inputImageTexture2; // 形变图
    uniform sampler2D maskTexture; // 遮罩
    uniform sampler2D inputImageTexture;  // 原图

    void main(){
        // 相邻像素采样跨度
           vec4 maskColor = texture2D(maskTexture, textureCoordinate);
           // 原图
           vec4 topLayer = texture2D(inputImageTexture, textureCoordinate);

           // 形变图
           vec4 color = texture2D(inputImageTexture2,textureCoordinate);
           color = mix(color, topLayer, maskColor.a);

           gl_FragColor = color;
    }