//#extension GL_OES_EGL_image_external : require

precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

//uniform vec2 uResolution;
//uniform vec2 uCenter1;
//uniform vec2 uCenter2;
//uniform float uRadius1;
//uniform float uRadius2;

const float number = 2.8;

float rgb2gray(vec4 color) {
    return color.r*0.19595+color.g*0.38469+color.b*0.7472;
}

float my_smoothstep(float edge0, float edge1, float x){
    float t = clamp((x - edge0) / (edge1 - edge0), 0.0, 1.0);
    return t * t * (3.0 - 2.0 * t);
}

void main(){
    lowp vec4 color = texture2D(inputImageTexture, textureCoordinate);
    lowp vec4 maskColor = texture2D(inputImageTexture2, textureCoordinate);

    if (maskColor.a > 0.1) {
        vec2 step1 = vec2(0.00208, 0.0);
        vec2 step2 = vec2(0.0, 0.001388);
        lowp vec3 sumColor = vec3(0.0);
        mediump float p = 0.0;
        mediump float t = 0.0;
        for(t = -2.0; t < 2.5; t += 1.0){
            for(p = -2.0; p < 2.5; p += 1.0){
                sumColor += texture2D(inputImageTexture, textureCoordinate + t * step1 + p * step2).rgb;
            }
        }
        sumColor = sumColor * 0.04;
        vec3 ttt = clamp(sumColor + (color.rgb - sumColor) * number, 0.0, 1.0);
        ttt = max(color.rgb, ttt);
        vec4 overlay = vec4(ttt, color.a);

        //    float gray = rgb2gray(overlay) * 255.0;
        //    if (gray > 240.0) {
        //        ttt = clamp(sumColor + (color.rgb - sumColor) * 1.8, 0.0, 1.0);
        //        overlay = vec4(ttt, color.a);
        //        overlay = color;
        //    }

        //    float r1 = uRadius1;
        //    float r2 = uRadius2;
        //    vec2 cords = textureCoordinate.xy * uResolution;
        //    float d1 = distance(cords, uCenter1);
        //    float d2 = distance(cords, uCenter2);
        //    float d = d1;
        //    float r = r1;
        //    if(d1 > d2){
        //        r = r2; d = d2;
        //    }
        //    float adj = 1.0 - my_smoothstep(0.5, 1.0, d / r);
        //    color = mix(color, overlay, adj);
        //
        //    gl_FragColor = color;
        gl_FragColor = overlay;
    } else {
        gl_FragColor = color;
    }
}