precision highp float;
precision highp int;

varying vec2 textureCoordinate;
//varying vec2 textureCoordinate2; // TODO: This is not used

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2; // lookup texture

uniform lowp float intensity;

// (x0, y0, radius)
//uniform lowp vec3 uLeftEye;
//uniform lowp vec3 uRightEye;
//
//uniform vec2 uResolution;

uniform int uShowEyes; // debug

vec4 lookup(vec4 src, float intensity) {
    float blueColor = src.b * 63.0;

    vec2 quad1;
    quad1.y = floor(floor(blueColor) / 8.0);
    quad1.x = floor(blueColor) - (quad1.y * 8.0);

    vec2 quad2;
    quad2.y = floor(ceil(blueColor) / 8.0);
    quad2.x = ceil(blueColor) - (quad2.y * 8.0);

    vec2 texPos1;
    texPos1.x = (quad1.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * src.r);
    texPos1.y = (quad1.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * src.g);

    vec2 texPos2;
    texPos2.x = (quad2.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * src.r);
    texPos2.y = (quad2.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * src.g);

    lowp vec4 newColor1 = texture2D(inputImageTexture2, texPos1);
    lowp vec4 newColor2 = texture2D(inputImageTexture2, texPos2);

    lowp vec4 newColor = mix(newColor1, newColor2, fract(blueColor));
    vec4 result = mix(src, vec4(newColor.rgb, src.w), intensity);
    return result;
}

void main()
{
    vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    vec4 lookupColor = lookup(textureColor, intensity);

    /*vec2 coord = uResolution.xy * textureCoordinate.xy;
    vec2 centerL = uResolution.xy * uLeftEye.xy;
    vec2 centerR = uResolution.xy * uRightEye.xy;
    float radiusL = uResolution.x * uLeftEye.z;
    float radiusR = uResolution.x * uRightEye.z;
    float dL = distance(centerL, coord);
    float dR = distance(centerR, coord);

    if (dL < radiusL || dR < radiusR) {
        float r = radiusL; float d = dL;
        if (dR < radiusR) {
            r = radiusR;
            d = dR;
        }

        float edge = r * 0.3;
        float factor = smoothstep(0.0, 1.0, (clamp(0.0, r, d - r) + edge) / edge);

        vec4 result = mix(textureColor, lookupColor, factor);

        if (uShowEyes > 0) result = vec4(1.0, 0.0, 0.0, 1.0); /// debug

        gl_FragColor = result;
    } else */{
        gl_FragColor = lookupColor;
    }
}
